{named_events4.i}

/*
PUBLISH event-name
[ FROM publisher-handle ]
[ ( parameter [ , parameter ] ... ) ]

SUBSCRIBE [ PROCEDURE subscriber-handle ] [ TO ] event-name
{ IN publisher-handle | ANYWHERE }
[ RUN-PROCEDURE local-internal-procedure ] [ NO-ERROR ]

UNSUBSCRIBE [ PROCEDURE subscriber-handle ]
[ TO ] { event-name | ALL } [ IN publisher-handle ]
*/

def var i as int.

procedure ev1.
   def input param k as int.
   i = i + 1.
   if (k <> i)
      then message "case " string(k) " is wrong".
end.

procedure ev3.
   def input param k as int.
end.

procedure ev4.
   /* call something which is known to raise an error, like SUBSCRIBE with invalid handles */
   def var hh as handle.
   hh = ?.
   subscribe to "ev1" in hh.
end.

h = ?.
publish "ev1" from h.
checkError(1, yes, 1, "Could not evaluate publisher handle expression while trying to execute PUBLISH statement. (6472)", 6472).

h = session.
publish "ev1" from h.
checkError(2, yes, 1, "Invalid or inappropriate publisher handle value given to PUBLISH statement. (9072)", 9072).

run named_events4empty.p persistent set h.
delete object h.
publish "ev1" from h.
checkError(3, yes, 1, "Invalid or inappropriate publisher handle value given to PUBLISH statement. (9072)", 9072).

publish "ev1".
checkError(4, no, 0, "", 0).

run named_events4empty.p persistent set h.

subscribe to "ev1" anywhere.
publish "ev1"(1).
checkError(5, no, 0, "", 0).

subscribe to "ev2" in h.
publish "ev2" from h(2). 
checkError(6, yes, 1, "PUBLISH statement failed. Procedure named_events4c.p has no entry point for ev2. (6480)", 6480).

unsubscribe to all in h.
checkError(7, no, 0, "", 0).
publish "ev2"(1).
checkError(8, no, 0, "", 0).

subscribe to "ev3" in h.
publish "ev3" from h.
checkError(9, yes, 1, "Mismatched number of parameters passed to routine ev3 named_events4c.p. (3234)", 3234).
unsubscribe to all in h.
checkError(10, no, 0, "", 0).

subscribe to "ev4" in h.
publish "ev4" from h.
checkError(11, no, 0 , "", 0).
unsubscribe to all in h.
checkError(12, no, 0, "", 0).
